####################
# version 2.0
####################


################################################################################
#                                                                              #
# NAME Core.IO.section 
# DESC Section Reader
#                                                                              #
################################################################################
"""
:NAME:
Core.IO.section

:DESC:
Section Reader

"""
# IMPORTS
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# IMPORTS

# CODE
#-------------------------------------------------------------------------------
class SectionIterator:
    """Read section file where sections are separated by a separator default=//
    
    Example:
    section 1
    //
    section 2
    //
    
    """
    def __init__(self, f, separator='//'):
        """
        f         -- file
        separator -- string seaprator
        """
        self.f = f
        self.separator = separator

    def __iter__(self):
        return self

    def next(self):
        """Read next section
        return the string corresponding to section data
        """
        l = []
        eof = False

        while 1:
            line = self.f.readline()
            if not line:
                eof = True
                break

            if line.startswith(self.separator):
                break
            l.append(line)

        if eof:
            raise StopIteration
        else:
            return ''.join(l)

#-------------------------------------------------------------------------------
# CODE
