####################
# version 2.0
####################




class MemoryCache(object):
    """
    simple memory cache
    key value association
    """
    def __init__(self, f):
        self.data = {}
        self.f = f
        self.access = 0
        self.success = 0

    def get(self, key):
        try:
            return self.data[key]
        except KeyError:
            self.data[key] = self.f.__call__(key)
            return self.data[key]
        
    def __call__(self, *args):
        self.access += 1
        if not self.data.has_key(args):
            self.data[args] = self.f(*args)
        else:
            self.success += 1
        return self.data[args]
        
    def stats(self):
        return 'efficency: %.3f' % ( self.success / float(self.access))