####################
# version 2.0
####################


from math import *

#LOG = {}
#for x in range(1, 10000):
#    LOG[x] = log(x)

def pbinom(n, N, p):
    """Compute P(x>=n) (binomial)
    n -- number of success
    N -- number of trials
    p -- prob of success
    """
    assert(p > 0 and p <= 1.0)
    assert(n <= N)

    if n == 0 or p == 1:
        return 1.0

    logp = log(p)
    logq = log(1-p)
    logbin = N * logq

    S = 0.0
    for x in range(1, N+1):
        #try:
        #    logbin += LOG[N - x + 1] - LOG[x] + logp - logq
        #except KeyError:
        logbin += log(N - x + 1) - log(x) + logp - logq
        if x >= n:
            S += exp(logbin)
        if x > N*p and exp(logbin) <= 0.0:
            break

    return max(min(S, 1.0), 0.0)

def ppois(n, lamb):
    """Compute P(x>=n) (Poisson)
    """
    assert(n >= 1)
    assert (lamb >= 0)
    
    loglamb = log(lamb)
    logpois = -lamb + loglamb

    S = 0.0
    if n == 1:
        S += exp(logpois)

    x = 2
    while not (x > lamb and exp(logpois) <= 0):
        logpois += loglamb - log(x)
        if x >= n:
            S += exp(logpois)
        x += 1
    #print x, lamb, exp(logpois)
    return max(min(S, 1.0), 0.0)


