####################
# version 2.0
####################


"""
Utilities to compute score distribution

methods:
    score2pvalue
    pvalue2score
    pvalue2score_noover
    

"""
from numpy import *


import Bio.sequence
import Bio.pwm
import Stats.utils




def score2pvalue(d, score):
    """
    Converts a score to a p-value
    
    """
    return Stats.utils.value2pvalue(d, score)



def pvalue2score(d, pvalue):
    """
    Converts a pvalue to a score
     
    """
    return Stats.utils.pvalue2value(d, pvalue)

    
def pvalue2score_nooverlap(d, pvalue, psfm):
    """
    Converts a pvalue to a score using a psfm
    
    """
    M = len(psfm)
    p = (1 - sqrt(1-4*M*pvalue)) / (2.0 * M)
    return pvalue2score(d, p)


#def score_distribution(m,lACGT):
#    """
#    Compute a score distribution for matrix
    
#    m      -- a weight matrix
#    lACGT  -- probability for a letter
    
#    return -- an array of score values
#    """    
#    H0 = {0:1.0}
#    for pos in range(len(m)):
#        H1   = {}
#        for letter in range(4):
#            for sc in H0.keys():
#                S = sc + m[pos,letter]
#                H1[S] = H1.get(S, 0) + \
#                    H0[sc] * lACGT[letter]
#        H0 = H1                        
#    d = H0
#    return d
